/*
 *  Copyright © 2020 Nick Bowler
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef TEST_FOOABLE_H_
#define TEST_FOOABLE_H_

#include <glib-object.h>

#define TEST_TYPE_FOOABLE (test_fooable_get_type())
#define TEST_FOOABLE(obj) \
	G_TYPE_CHECK_INSTANCE_CAST(obj, TEST_TYPE_FOOABLE, TestFooableIface)
#define TEST_IS_FOOABLE(obj) G_TYPE_CHECK_INSTANCE_TYPE(obj, TEST_TYPE_FOOABLE)
#define TEST_FOOABLE_GET_INTERFACE(inst) \
	G_TYPE_INSTANCE_GET_INTERFACE(inst, TEST_TYPE_FOOABLE, TestFooableIface)

typedef struct TestFooableIface TestFooableIface;
struct TestFooableIface {
	GTypeInterface parent;

	int (*foo)(GObject *obj);
};

GType test_fooable_get_type(void);
int test_foo(GObject *go);

#endif
